#NoTrayIcon
#AutoIt3Wrapper_icon=img\icon.ico
#AutoIt3Wrapper_outfile=Remote LAN Control.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Comment=Created by: Micha Morawski (aka moras86)
#AutoIt3Wrapper_Res_Description=Desktop app to control Samsung B-series HDTV via LAN.
#AutoIt3Wrapper_Res_Fileversion=0.6.0.22
#AutoIt3Wrapper_Res_LegalCopyright=SamyGO.tv  2011

#cs ----------------------------------------
 AutoIt: 3.3.6.11
 Author: moras86
 Function: Remote LAN Control - Samsung HDTV
 Version: 0.6
#ce ----------------------------------------

#include <GUIConstantsEx.au3>
#include <GUIStatusBar.au3>
#include <GuiIPAddress.au3>
#Include <WinAPIEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#Include <Restart.au3>

Global $cnt_www=1000,$cnt_tv_app=1000,$cnt_pc_app=1000,$cnt_about,$cnt_config,$cnt_buttons,$config_box
Global $btn_power,$btn_tv,$btn_1,$btn_2,$btn_3,$btn_1e,$btn_2e,$btn_3e,$btn_4,$btn_5,$btn_6,$btn_4e,$btn_5e,$btn_6e,$btn_7,$btn_8,$btn_9,$btn_7e,$btn_8e,$btn_9e,$btn_0,$btn_0e
Global $btn_favch,$btn_prech,$btn_volup,$btn_mute,$btn_chup,$btn_voldn,$btn_source,$btn_chdn,$btn_info,$btn_menu,$btn_guide,$btn_tools,$btn_return,$btn_enter,$btn_up,$btn_left
Global $btn_right,$btn_down,$btn_intern,$btn_exit,$btn_red,$btn_green,$btn_yellow,$btn_blue,$btn_ttx,$btn_media,$btn_conten,$btn_chlist,$btn_ad,$btn_subt,$btn_fb,$btn_pause
Global $btn_ff,$btn_rec,$btn_play,$btn_stop,$btn_srs,$btn_sleep,$btn_pip,$btn_pip1,$btn_pip2,$btn_energy,$btn_pmode,$btn_dynamic,$btn_standard,$btn_movie,$btn_smode,$btn_psize
Global $btn_asp43,$btn_asp169,$btn_scart1,$btn_scart2,$btn_hdmi1,$btn_hdmi2,$btn_hdmi3,$btn_hdmi4,$btn_module,$btn_vga,$btn_av,$btn_dual,$btn_user_seq
Global $btn_dvb,$btn_hnc,$btn_spk,$btn_pip_x
Global $iLastTab=0

$version = "0.6"

$config = @ScriptDir & "\config.ini"
$tv_ip				= IniRead($config, "connect", "ip", "0.0.0.0")
$tv_model			= IniRead($config, "model", "tv", "B650")
$tv_remote			= IniRead($config, "model", "rc", "938")
$user_btn			= IniRead($config, "user button", "active", "0")
$user_box_name		= IniRead($config, "user button", "box name", "")
$user_btn_name1		= IniRead($config, "user button", "name1", "")
$user_btn_keycode1	= IniRead($config, "user button", "keycode1", "")
$user_btn_name2		= IniRead($config, "user button", "name2", "")
$user_btn_keycode2	= IniRead($config, "user button", "keycode2", "")
$user_btn_seq		= IniRead($config, "user button", "seq", "0")
$user_btn_name		= IniRead($config, "user button", "name", "")
$user_btn_key1		= IniRead($config, "user button", "key1", "")
$user_btn_key2		= IniRead($config, "user button", "key2", "")
$user_btn_key3		= IniRead($config, "user button", "key3", "")
$user_btn_key4		= IniRead($config, "user button", "key4", "")
$user_btn_key5		= IniRead($config, "user button", "key5", "")
$user_btn_key6		= IniRead($config, "user button", "key6", "")
$user_btn_key7		= IniRead($config, "user button", "key7", "")
$user_btn_key8		= IniRead($config, "user button", "key8", "")
$user_btn_key9		= IniRead($config, "user button", "key9", "")
$user_btn_key0		= IniRead($config, "user button", "key0", "")
$hotkeys_numeric	= IniRead($config, "hotkeys", "numeric", "1")
$hotkeys_arrows		= IniRead($config, "hotkeys", "arrows", "1")
$hotkeys_media		= IniRead($config, "hotkeys", "media", "1")
$extra_buttons		= IniRead($config, "extra buttons", "visible", "1")
$fast_btn			= IniRead($config, "other", "fast_btn", "0")
$info_ch			= IniRead($config, "other", "info_ch", "0")
$alt_dvb			= IniRead($config, "other", "alt_dvb", "0")
$tv_app				= IniRead($config, "link", "tv_app", "")
$pc_app				= IniRead($config, "link", "pc_app", "")

$width=450
If $tv_model <> "" Then
	If $tv_model = "B650" Then
		If $extra_buttons = "1" Then
			$width=450
		ElseIf $extra_buttons = "0" Then
			$width=280
		Endif
	ElseIf $tv_model = "B6000" Then
		$width=280
	Endif
Endif
$btn_width=50
If $fast_btn = "0" Then
	$btn_width=60
Endif

Opt("GUIOnEventMode", 1)

$GUI = GUICreate("Remote LAN Control :: Samsung", $width, 635)
GUISetBkColor(0xFFFFFF)
GuiSetIcon("img\icon.ico", 0)
GUISetState()
GuiSetOnEvent($GUI_EVENT_CLOSE,	"end")
$status = _GUICtrlStatusBar_Create($GUI)
GUICtrlCreatePic(@ScriptDir & "\img\bg.jpg",	  0,  10, 280, 600)
GUICtrlSetState(-1, $GUI_DISABLE)

$Context = GUICtrlCreateContextMenu()
$cnt_config = GUICtrlCreateMenuItem("Configuration", $Context)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
If $tv_model = "B650" Then
	If $extra_buttons = "1" Then
		$cnt_buttons = GUICtrlCreateMenuItem("Hide extra buttons panel", $Context)
	ElseIf $extra_buttons = "0" Then
		$cnt_buttons = GUICtrlCreateMenuItem("Show extra buttons panel", $Context)
	EndIf
EndIf
GUICtrlCreateMenuItem("", $Context)
$Context_sub = GUICtrlCreateMenu("Download", $Context)
$cnt_tv_app = GUICtrlCreateMenuItem("Download TV app", $Context_sub)
	If $tv_app = "" Then GUICtrlSetState(-1, $GUI_DISABLE)
$cnt_pc_app = GUICtrlCreateMenuItem("Check for new version", $Context_sub)
	If $pc_app = "" Then GUICtrlSetState(-1, $GUI_DISABLE)
$cnt_www = GUICtrlCreateMenuItem("SamyGO.tv", $Context)
GUICtrlCreateMenuItem("", $Context)
$cnt_about = GUICtrlCreateMenuItem("About", $Context)

If $tv_model <> "" Then
	If $tv_model = "B650" Then
		If $tv_remote = "938" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)
$btn_tv		= GUICtrlCreateButton("TV",			 45,  55,  60,  25)

$btn_1		= GUICtrlCreateButton("1",			 45,  85,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  85,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  85,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
$btn_2e		= GUICtrlCreateButton("",			160,  85,  10,  15)
$btn_3e		= GUICtrlCreateButton("",			225,  85,  10,  15)

$btn_4		= GUICtrlCreateButton("4",			 45, 115,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110, 115,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175, 115,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
$btn_5e		= GUICtrlCreateButton("",			160, 115,  10,  15)
$btn_6e		= GUICtrlCreateButton("",			225, 115,  10,  15)

$btn_7		= GUICtrlCreateButton("7",			 45, 145,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 145,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 145,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 145,  10,  15)
$btn_8e		= GUICtrlCreateButton("",			160, 145,  10,  15)
$btn_9e		= GUICtrlCreateButton("",			225, 145,  10,  15)

$btn_favch	= GUICtrlCreateButton("FAV.CH",		 45, 175,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 175,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 175,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 175,  10,  15)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 205,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 210,  40,  20)
$btn_chup	= GUICtrlCreateButton("P +",		175, 205,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 235,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 240,  40,  20)
$btn_chdn	= GUICtrlCreateButton("P -",		175, 235,  60,  30)

$btn_info	= GUICtrlCreateButton("INFO",		 45, 270,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 270,  60,  30)
$btn_guide	= GUICtrlCreateButton("GUIDE",		175, 270,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 295,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 295,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 338,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 310,  60,  20)
$btn_left	= GUICtrlCreateButton("<",			 90, 330,  20,  60)
$btn_right	= GUICtrlCreateButton(">",			170, 330,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 390,  60,  20)

$btn_intern = GUICtrlCreateButton("INTERNET",	 45, 395,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 395,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 430,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 430,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 430,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 430,  44,  20)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 455,  60,  20)
$btn_media	= GUICtrlCreateButton("MEDIA.P",	110, 455,  60,  20)
$btn_conten	= GUICtrlCreateButton("CONTENT",	175, 455,  60,  20)

$btn_chlist	= GUICtrlCreateButton("CH LIST",	 45, 480,  60,  20)
$btn_ad		= GUICtrlCreateButton("AD",			110, 480,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 480,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 505,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 505,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 505,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 530,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 530,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 530,  60,  20)

GuiCtrlCreateLabel("BN59-00938A",	51, 560)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GuiCtrlSetColor(-1, 0xFFFFFF)
GUICtrlSetFont(-1, 6)

		ElseIf $tv_remote = "861" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)
$btn_tv		= GUICtrlCreateButton("TV",			 45,  55,  60,  25)

$btn_1		= GUICtrlCreateButton("1",			 45,  85,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  85,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  85,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
$btn_2e		= GUICtrlCreateButton("",			160,  85,  10,  15)
$btn_3e		= GUICtrlCreateButton("",			225,  85,  10,  15)

$btn_4		= GUICtrlCreateButton("4",			 45, 115,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110, 115,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175, 115,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
$btn_5e		= GUICtrlCreateButton("",			160, 115,  10,  15)
$btn_6e		= GUICtrlCreateButton("",			225, 115,  10,  15)

$btn_7		= GUICtrlCreateButton("7",			 45, 145,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 145,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 145,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 145,  10,  15)
$btn_8e		= GUICtrlCreateButton("",			160, 145,  10,  15)
$btn_9e		= GUICtrlCreateButton("",			225, 145,  10,  15)

$btn_enter	= GUICtrlCreateButton("ENTER",		 45, 175,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 175,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 175,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 175,  10,  15)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 205,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 210,  40,  20)
$btn_chup	= GUICtrlCreateButton("P +",		175, 205,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 235,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 240,  40,  20)
$btn_chdn	= GUICtrlCreateButton("P -",		175, 235,  60,  30)

$btn_chlist	= GUICtrlCreateButton("CH LIST",	 45, 270,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 270,  60,  30)
$btn_favch	= GUICtrlCreateButton("FAV.CH",		175, 270,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 295,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 295,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 338,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 310,  60,  20)
$btn_left	= GUICtrlCreateButton("<",			 90, 330,  20,  60)
$btn_right	= GUICtrlCreateButton(">",			170, 330,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 390,  60,  20)

$btn_intern = GUICtrlCreateButton("INTERNET",	 45, 395,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 395,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 430,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 430,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 430,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 430,  44,  20)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 455,  60,  20)
$btn_media	= GUICtrlCreateButton("MEDIA.P",	110, 455,  60,  20)
$btn_conten	= GUICtrlCreateButton("CONTENT",	175, 455,  60,  20)

$btn_info	= GUICtrlCreateButton("INFO",		 45, 480,  60,  20)
$btn_guide	= GUICtrlCreateButton("GUIDE",		110, 480,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 480,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 505,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 505,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 505,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 530,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 530,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 530,  60,  20)

GuiCtrlCreateLabel("BN59-00861A",	51, 560)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GuiCtrlSetColor(-1,0xFFFFFF)
GUICtrlSetFont(-1, 6)

		EndIf

GuiCtrlCreateGroup("Aspect ratio",		285,  10, 150,  71)
	$btn_asp43	= GUICtrlCreateButton("4:3",			290,  25,  70,  25)
	$btn_asp169	= GUICtrlCreateButton("16:9",			360,  25,  70,  25)
	$btn_psize	= GUICtrlCreateButton("Picture size",	290,  50,  70,  25)
GUICtrlCreateGroup ("",-99,-99,1,1)

GuiCtrlCreateGroup("Picture mode",		285,  80, 150, 71)
	$btn_pmode		= GUICtrlCreateButton("Switch mode",	290,  95,  70,  25)
	$btn_dynamic	= GUICtrlCreateButton("Dynamic",		360,  95,  70,  25)
	$btn_standard	= GUICtrlCreateButton("Standard",		290, 120,  70,  25)
	$btn_movie		= GUICtrlCreateButton("Movie",			360, 120,  70,  25)
GUICtrlCreateGroup ("",-99,-99,1,1)

GuiCtrlCreateGroup("Direct source",		285, 150, 150, 146)
	$btn_scart1	= GUICtrlCreateButton("Scart 1",	290, 165,  70,  25)
	$btn_hdmi1	= GUICtrlCreateButton("HDMI 1",		360, 165,  70,  25)
	$btn_scart2	= GUICtrlCreateButton("Scart 2",	290, 190,  70,  25)
	$btn_hdmi2	= GUICtrlCreateButton("HDMI 2",		360, 190,  70,  25)
	$btn_module	= GUICtrlCreateButton("Module",		290, 215,  70,  25)
	$btn_hdmi3	= GUICtrlCreateButton("HDMI3/DVI",	360, 215,  70,  25)
	$btn_av		= GUICtrlCreateButton("AV", 		290, 240,  70,  25)
	$btn_hdmi4	= GUICtrlCreateButton("HDMI 4",		360, 240,  70,  25)
	$btn_vga	= GUICtrlCreateButton("VGA (PC)",	290, 265,  70,  25)
GUICtrlCreateGroup ("",-99,-99,1,1)

GuiCtrlCreateGroup("PIP",				285, 295, 150,  71)
	$btn_pip	= GUICtrlCreateButton("PIP on/off",		290, 310,  70,  25)
	$btn_pip1	= GUICtrlCreateButton("Full mode 1",	360, 310,  70,  25)
	$btn_pip2	= GUICtrlCreateButton("Full mode 2",	290, 335,  70,  25)
	$btn_pip_x	= GUICtrlCreateButton("Exit PIP",		360, 335,  70,  25)
GUICtrlCreateGroup ("",-99,-99,1,1)

GuiCtrlCreateGroup("Extra keys",		285, 365, 150,  71)
	$btn_energy	= GUICtrlCreateButton("Energy save",	290, 380,  70,  25)
	$btn_sleep	= GUICtrlCreateButton("Sleep",			360, 380,  70,  25)
	$btn_srs	= GUICtrlCreateButton("SRS on/off",		290, 405,  70,  25)
	$btn_smode	= GUICtrlCreateButton("Sound mode",		360, 405,  70,  25)
GUICtrlCreateGroup ("",-99,-99,1,1)

GuiCtrlCreateGroup("Keys sequences",	285, 435, 150,  71)
	$btn_dvb	= GUICtrlCreateButton("DVB signal",		290, 450,  70,  25)
	$btn_hnc	= GUICtrlCreateButton("Home Net",		360, 450,  70,  25)
	$btn_spk	= GUICtrlCreateButton("Sel.Speakers",	290, 475,  70,  25)
	If $user_btn_seq = "1" Then
		$btn_user_seq = GUICtrlCreateButton($user_btn_name,	360, 475,  70,  25)
		GUICtrlSetOnEvent($btn_user_seq,	"key_user_seq")
	Endif
GUICtrlCreateGroup ("",-99,-99,1,1)

If $user_btn <> "0" Then
	If $user_btn >= "1" Then
		$btn_user1 = GUICtrlCreateButton($user_btn_name1,	290, 520,  70,  25)
		GUICtrlSetOnEvent($btn_user1,	"key_user1")
		If $user_btn = "2" Then
			$btn_user2 = GUICtrlCreateButton($user_btn_name2,	360, 520,  70,  25)
			GUICtrlSetOnEvent($btn_user2,	"key_user2")
		Endif
	Endif
	GuiCtrlCreateGroup($user_box_name,	285, 505, 150, 46)
	GUICtrlCreateGroup("",-99,-99,1,1)
Endif

$progress = GUICtrlCreateProgress(290, 575, 140, 15)
GUICtrlSetLimit(-1, 100, 0)
GUICtrlSetState(-1, $GUI_HIDE)
GUICtrlSetState($btn_pip_x, $GUI_DISABLE)

	ElseIf $tv_model = "B6000" Then

$btn_power	= GUICtrlCreateButton("Power OFF",	 45,  25,  60,  25)
$btn_tv		= GUICtrlCreateButton("TV",			175,  25,  60,  25)

$btn_1		= GUICtrlCreateButton("1",			 45,  55,  $btn_width,  25)
$btn_2		= GUICtrlCreateButton("2",			110,  55,  $btn_width,  25)
$btn_3		= GUICtrlCreateButton("3",			175,  55,  $btn_width,  25)
$btn_1e		= GUICtrlCreateButton("",			 95,  55,  10,  15)
$btn_2e		= GUICtrlCreateButton("",			160,  55,  10,  15)
$btn_3e		= GUICtrlCreateButton("",			225,  55,  10,  15)

$btn_4		= GUICtrlCreateButton("4",			 45,  85,  $btn_width,  25)
$btn_5		= GUICtrlCreateButton("5",			110,  85,  $btn_width,  25)
$btn_6		= GUICtrlCreateButton("6",			175,  85,  $btn_width,  25)
$btn_4e		= GUICtrlCreateButton("",			 95,  85,  10,  15)
$btn_5e		= GUICtrlCreateButton("",			160,  85,  10,  15)
$btn_6e		= GUICtrlCreateButton("",			225,  85,  10,  15)

$btn_7		= GUICtrlCreateButton("7",			 45, 115,  $btn_width,  25)
$btn_8		= GUICtrlCreateButton("8",			110, 115,  $btn_width,  25)
$btn_9		= GUICtrlCreateButton("9",			175, 115,  $btn_width,  25)
$btn_7e		= GUICtrlCreateButton("",			 95, 115,  10,  15)
$btn_8e		= GUICtrlCreateButton("",			160, 115,  10,  15)
$btn_9e		= GUICtrlCreateButton("",			225, 115,  10,  15)

$btn_enter	= GUICtrlCreateButton("ENTER",		 45, 145,  60,  25)
$btn_0		= GUICtrlCreateButton("0",			110, 145,  $btn_width,  25)
$btn_prech	= GUICtrlCreateButton("PRE-CH",		175, 145,  60,  25)
$btn_0e		= GUICtrlCreateButton("",			160, 145,  10,  15)

$btn_chlist	= GUICtrlCreateButton("CH LIST",	 45, 175,  60,  20)
$btn_menu	= GUICtrlCreateButton("MENU",		110, 175,  60,  30)
$btn_favch	= GUICtrlCreateButton("FAV.CH",		175, 175,  60,  20)

$btn_tools	= GUICtrlCreateButton("TOOLS",		 45, 200,  60,  30)
$btn_return	= GUICtrlCreateButton("RETURN",		175, 200,  60,  30)

$btn_enter	= GUICtrlCreateButton("ENTER",		118, 243,  44,  44)
$btn_up		= GUICtrlCreateButton("^",			110, 215,  60,  20)
$btn_left	= GUICtrlCreateButton("<",			 90, 235,  20,  60)
$btn_right	= GUICtrlCreateButton(">",			170, 235,  20,  60)
$btn_down	= GUICtrlCreateButton("v",			110, 295,  60,  20)

$btn_info	= GUICtrlCreateButton("INFO",		 45, 300,  60,  30)
$btn_exit	= GUICtrlCreateButton("EXIT",		175, 300,  60,  30)

$btn_red	= GUICtrlCreateButton("R",			 45, 335,  44,  20)
$btn_green	= GUICtrlCreateButton("G",			 94, 335,  44,  20)
$btn_yellow	= GUICtrlCreateButton("Y",			142, 335,  44,  20)
$btn_blue	= GUICtrlCreateButton("B",			191, 335,  44,  20)

$btn_volup	= GUICtrlCreateButton("VOL +",		 45, 360,  60,  30)
$btn_mute	= GUICtrlCreateButton("Mute",		120, 365,  40,  20)
$btn_chup	= GUICtrlCreateButton("CH +",		175, 360,  60,  30)
$btn_voldn	= GUICtrlCreateButton("VOL -",		 45, 390,  60,  30)
$btn_source	= GUICtrlCreateButton("Source",		120, 395,  40,  20)
$btn_chdn	= GUICtrlCreateButton("CH -",		175, 390,  60,  30)

$btn_ttx	= GUICtrlCreateButton("TTX/MIX",	 45, 425,  60,  20)
$btn_media	= GUICtrlCreateButton("MEDIA.P",	110, 425,  60,  20)
$btn_psize	= GUICtrlCreateButton("P.SIZE",		175, 425,  60,  20)

$btn_dual	= GUICtrlCreateButton("DUAL",		 45, 450,  60,  20)
$btn_guide	= GUICtrlCreateButton("GUIDE",		110, 450,  60,  20)
$btn_subt	= GUICtrlCreateButton("SUBT.",		175, 450,  60,  20)

$btn_fb		= GUICtrlCreateButton("<|<|",		 45, 475,  60,  20)
$btn_pause	= GUICtrlCreateButton("| |",		110, 475,  60,  20)
$btn_ff		= GUICtrlCreateButton("|>|>",		175, 475,  60,  20)

$btn_rec	= GUICtrlCreateButton("REC ( )",	 45, 500,  60,  20)
$btn_play	= GUICtrlCreateButton("|>",			110, 500,  60,  20)
$btn_stop	= GUICtrlCreateButton("STOP [ ]",	175, 500,  60,  20)
	Endif
Endif

If $fast_btn = "0" Then
	$btn_width=60
	GUICtrlSetState($btn_1e, $GUI_HIDE)
	GUICtrlSetState($btn_2e, $GUI_HIDE)
	GUICtrlSetState($btn_3e, $GUI_HIDE)
	GUICtrlSetState($btn_4e, $GUI_HIDE)
	GUICtrlSetState($btn_5e, $GUI_HIDE)
	GUICtrlSetState($btn_6e, $GUI_HIDE)
	GUICtrlSetState($btn_7e, $GUI_HIDE)
	GUICtrlSetState($btn_8e, $GUI_HIDE)
	GUICtrlSetState($btn_9e, $GUI_HIDE)
	GUICtrlSetState($btn_0e, $GUI_HIDE)
Endif

If _WinAPI_GetVersion() > '6.0' Then
	If _WinAPI_IsInternetConnected() Then
		$connected = "  |  Internet: Connected"
	Else
		$connected = "  |  Internet: Not Connected!"
	EndIf
Else
	$connected = ""
EndIf

_GUICtrlStatusBar_SetText($status, " TV: " & $tv_model & "  |  IP: " & $tv_ip & $connected)

GuiCtrlCreateLabel("v" & $version, 344, 618, 100, 20, $SS_RIGHT)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GuiCtrlSetColor(-1, 0x909090)

$GUI_config = GUICreate("Configuration", 345, 230)
GUISetStyle(BitOR($WS_SYSMENU,$WS_CAPTION,$WS_BORDER))
	$tv_ip_input = _GUICtrlIpAddress_Create($GUI_config, 52, 37, 130, 20)
	_GUICtrlIpAddress_Set($tv_ip_input, $tv_ip)
$GUI_config = GUISetState(@SW_HIDE)
$GUI_config = GuiSetOnEvent($GUI_EVENT_CLOSE,	"config_box")

	$Tab = GUICtrlCreateTab(0, 5, 347, 236)
	GUICtrlSetOnEvent(-1, "_Tab_Switch")
	GUICtrlCreateTabItem("Connect")
		GUICtrlCreateLabel("TV IP:", 15, 40)
		GUICtrlCreateLabel("You local network PC IP: " & @IPAddress1, 15, 70)
		GuiCtrlSetColor(-1,0x808080)
	GUICtrlCreateTabItem("Remote")
		GUICtrlCreateLabel("Choose you Samsung TV model:", 15, 40)
		$tv_model_b650 = GUICtrlCreateRadio("B650", 20, 60)
		$tv_model_b6000 = GUICtrlCreateRadio("B6000 - LED", 20, 85)
		If $tv_model = "B650" Then
			GUICtrlSetState($tv_model_b650, $GUI_CHECKED)
		ElseIf $tv_model = "B6000" Then
			GUICtrlSetState($tv_model_b6000, $GUI_CHECKED)
		EndIf
		$tv_remote_list = GUICtrlCreateCombo("", 125, 61, 90, 20)
		If $tv_remote = "938" Then
			GUICtrlSetData($tv_remote_list, "BN59-00938A|BN59-00861A", "BN59-00938A")
		ElseIf $tv_remote = "861" Then
			GUICtrlSetData($tv_remote_list, "BN59-00938A|BN59-00861A", "BN59-00861A")
		EndIf
	GUICtrlCreateTabItem("User buttons")
		GUICtrlCreateLabel("Create you own remote buttons", 15, 40)
		GuiCtrlCreateGroup(" ", 10, 60, 160, 70)
			GUICtrlCreateLabel("Label:", 10, 80, 50, 17, $SS_RIGHT)
			$user_btn_name1_input = GUICtrlCreateInput($user_btn_name1, 65, 77, 100, 20)
			GUICtrlSetLimit(-1, 15)
			GUICtrlCreateLabel("Keycode:", 10, 105, 50, 17, $SS_RIGHT)
			$user_btn_keycode1_input = GUICtrlCreateInput($user_btn_keycode1, 65, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
		GUICtrlCreateGroup ("",-99,-99,1,1)
		$user_button_active1 = GUICtrlCreateCheckbox("Button 1", 20, 56)
		GuiCtrlCreateGroup(" ", 175, 60, 160, 70)
			GUICtrlCreateLabel("Label:", 175, 80, 50, 17, $SS_RIGHT)
			$user_btn_name2_input = GUICtrlCreateInput($user_btn_name2, 230, 77, 100, 20)
			GUICtrlSetLimit(-1, 15)
			GUICtrlCreateLabel("Keycode:", 175, 105, 50, 17, $SS_RIGHT)
			$user_btn_keycode2_input = GUICtrlCreateInput($user_btn_keycode2, 230, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
		GUICtrlCreateGroup ("",-99,-99,1,1)
		$user_button_active2 = GUICtrlCreateCheckbox("Button 2", 185, 56)
		If $user_btn >= "1" Then
			GUICtrlSetState($user_button_active1, $GUI_CHECKED)
		ElseIf $user_btn = "2" Then
			GUICtrlSetState($user_button_active2, $GUI_CHECKED)
		EndIf
		GUICtrlCreateLabel("Section title:", 15, 140)
		$user_box_name_input = GUICtrlCreateInput($user_box_name, 77, 137, 150, 20)
	GUICtrlCreateTabItem("Sequence")
		GUICtrlCreateLabel("Preper own action button from keycodes sequence", 15, 40)
		GuiCtrlCreateGroup(" ", 10, 60, 310, 70)
			$user_btn_seq_active = GUICtrlCreateCheckbox("Button for keys sequence", 20, 56)
			If $user_btn_seq = "1" Then
				GUICtrlSetState($user_btn_seq_active, $GUI_CHECKED)
			EndIf
			GUICtrlCreateLabel("1.", 10, 80, 20, 17, $SS_RIGHT)
			$user_btn_key1_input = GUICtrlCreateInput($user_btn_key1, 35, 77, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("2.", 70, 80, 20, 17, $SS_RIGHT)
			$user_btn_key2_input = GUICtrlCreateInput($user_btn_key2, 95, 77, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("3.", 130, 80, 20, 17, $SS_RIGHT)
			$user_btn_key3_input = GUICtrlCreateInput($user_btn_key3, 155, 77, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("4.", 190, 80, 20, 17, $SS_RIGHT)
			$user_btn_key4_input = GUICtrlCreateInput($user_btn_key4, 215, 77, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("5.", 250, 80, 20, 17, $SS_RIGHT)
			$user_btn_key5_input = GUICtrlCreateInput($user_btn_key5, 275, 77, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("6.", 10, 105, 20, 17, $SS_RIGHT)
			$user_btn_key6_input = GUICtrlCreateInput($user_btn_key6, 35, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("7.", 70, 105, 20, 17, $SS_RIGHT)
			$user_btn_key7_input = GUICtrlCreateInput($user_btn_key7, 95, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("8.", 130, 105, 20, 17, $SS_RIGHT)
			$user_btn_key8_input = GUICtrlCreateInput($user_btn_key8, 155, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("9.", 190, 105, 20, 17, $SS_RIGHT)
			$user_btn_key9_input = GUICtrlCreateInput($user_btn_key9, 215, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
			GUICtrlCreateLabel("10.", 250, 105, 20, 17, $SS_RIGHT)
			$user_btn_key0_input = GUICtrlCreateInput($user_btn_key0, 275, 102, 35, 20)
			GUICtrlSetLimit(-1, 4)
		GUICtrlCreateGroup ("",-99,-99,1,1)
		GUICtrlCreateLabel("Button name:", 15, 140)
		$user_btn_name_input = GUICtrlCreateInput($user_btn_name, 84, 137, 100, 20)
		GUICtrlSetLimit(-1, 15)
		GUICtrlCreateLabel("TIP: For bigger delay spaces between key press, put dash ( - )" & @CRLF & "        symbol instead keycode.", 15, 160)
		GuiCtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("Hotkeys")
		GUICtrlCreateLabel("Active or disable hotkeys groups:", 15, 40)
		$hotkeys_numeric_active = GUICtrlCreateCheckbox("Numeric hotkeys", 20, 60)
		If $hotkeys_numeric = "1" Then
			GUICtrlSetState($hotkeys_numeric_active, $GUI_CHECKED)
		EndIf
		$hotkeys_arrows_active = GUICtrlCreateCheckbox("Arrows and Enter key", 20, 80)
		If $hotkeys_arrows = "1" Then
			GUICtrlSetState($hotkeys_arrows_active, $GUI_CHECKED)
		EndIf
		$hotkeys_media_active = GUICtrlCreateCheckbox("Multimedia keyboard hotkeys", 20, 100)
		If $hotkeys_media = "1" Then
			GUICtrlSetState($hotkeys_media_active, $GUI_CHECKED)
		EndIf
		GUICtrlCreateLabel("All hotkeys need too be use with [Control] key.", 15, 140)
		GuiCtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("Other")
		$extra_buttons_active = GUICtrlCreateCheckbox("Show extra buttons on app start *", 20, 40)
		If $extra_buttons = "1" Then
			GUICtrlSetState($extra_buttons_active, $GUI_CHECKED)
		EndIf
		$fast_btn_active = GUICtrlCreateCheckbox("Show buttons for fast change channel with numeric keys", 20, 60)
		If $fast_btn = "1" Then
			GUICtrlSetState($fast_btn_active, $GUI_CHECKED)
		EndIf
		$info_ch_active = GUICtrlCreateCheckbox("Display channel infos box always when use buttons CH +/-", 20, 80)
		If $info_ch = "1" Then
			GUICtrlSetState($info_ch_active, $GUI_CHECKED)
		EndIf
		$alt_dvb_active = GUICtrlCreateCheckbox("Alternative DVB checking signal sequence", 20, 100)
		If $alt_dvb = "1" Then
			GUICtrlSetState($alt_dvb_active, $GUI_CHECKED)
		EndIf
		GUICtrlCreateLabel("*) Setting depends of chosen TV model.", 15, 140)
		GuiCtrlSetColor(-1,0x404040)
	GUICtrlCreateTabItem("")

$btn_save_config	= GUICtrlCreateButton("Save", 15, 195, 50, 25)
GUICtrlSetOnEvent($btn_save_config,	"save_config")
$btn_restart_config	= GUICtrlCreateButton("Restart", 70, 195, 50, 25)
GUICtrlSetOnEvent($btn_restart_config,	"restart")
GUICtrlSetState($btn_restart_config, $GUI_DISABLE)

If $tv_ip = "0.0.0.0" Then
	MsgBox(48, "Error", "   Problem with IP address. Check you app configuration.")
	$GUI_config = GUISetState()
Endif

If $hotkeys_numeric = "1" Then
	HotKeySet("^{NUMPAD1}",		"key_1")
	HotKeySet("^{NUMPAD2}",		"key_2")
	HotKeySet("^{NUMPAD3}",		"key_3")
	HotKeySet("^{NUMPAD4}",		"key_4")
	HotKeySet("^{NUMPAD5}",		"key_5")
	HotKeySet("^{NUMPAD6}",		"key_6")
	HotKeySet("^{NUMPAD7}",		"key_7")
	HotKeySet("^{NUMPAD8}",		"key_8")
	HotKeySet("^{NUMPAD9}",		"key_9")
	HotKeySet("^{NUMPAD0}",		"key_0")
	HotKeySet("^{NUMPADADD}",	"key_chup")
	HotKeySet("^{NUMPADSUB}",	"key_chdn")
	HotKeySet("^{NUMPADDOT}",	"key_prech")
	HotKeySet("^{NUMPADENTER}",	"key_enter")
Endif

If $hotkeys_arrows = "1" Then
	HotKeySet("^{UP}",		"key_up")
	HotKeySet("^{DOWN}",	"key_down")
	HotKeySet("^{LEFT}",	"key_left")
	HotKeySet("^{RIGHT}",	"key_right")
	HotKeySet("^{ENTER}",	"key_enter")
Endif

If $hotkeys_media = "1" Then
	HotKeySet("^{LAUNCH_MEDIA}",	"key_media")
	HotKeySet("^{LAUNCH_MAIL}",		"key_intern")
	HotKeySet("^{VOLUME_UP}",		"key_volup")
	HotKeySet("^{VOLUME_DOWN}",		"key_voldn")
	HotKeySet("^{VOLUME_MUTE}",		"key_mute")
	HotKeySet("^{MEDIA_PLAY_PAUSE}","key_play")
	HotKeySet("^{MEDIA_STOP}",		"key_stop")
	HotKeySet("^{MEDIA_PREV}",		"key_fb")
	HotKeySet("^{MEDIA_NEXT}",		"key_ff")
	HotKeySet("^{BROWSER_FORWARD}",		"key_up")
	HotKeySet("^{BROWSER_BACK}",		"key_down")
	HotKeySet("^{BROWSER_FAVORITES}",	"key_favch")
	HotKeySet("^{BROWSER_HOME}",		"key_menu")
	HotKeySet("^{BROWSER_STOP}",		"key_return")
	HotKeySet("^{BROWSER_SEARCH}",		"key_conten")
Endif

HotKeySet("{EXIT}",	"end")

GUICtrlSetOnEvent($btn_power,	"key_power")
GUICtrlSetOnEvent($btn_tv,	"key_tv")
GUICtrlSetOnEvent($btn_1,	"key_1")
GUICtrlSetOnEvent($btn_2,	"key_2")
GUICtrlSetOnEvent($btn_3,	"key_3")
GUICtrlSetOnEvent($btn_1e,	"key_1e")
GUICtrlSetOnEvent($btn_2e,	"key_2e")
GUICtrlSetOnEvent($btn_3e,	"key_3e")
GUICtrlSetOnEvent($btn_4,	"key_4")
GUICtrlSetOnEvent($btn_5,	"key_5")
GUICtrlSetOnEvent($btn_6,	"key_6")
GUICtrlSetOnEvent($btn_4e,	"key_4e")
GUICtrlSetOnEvent($btn_5e,	"key_5e")
GUICtrlSetOnEvent($btn_6e,	"key_6e")
GUICtrlSetOnEvent($btn_7,	"key_7")
GUICtrlSetOnEvent($btn_8,	"key_8")
GUICtrlSetOnEvent($btn_9,	"key_9")
GUICtrlSetOnEvent($btn_7e,	"key_7e")
GUICtrlSetOnEvent($btn_8e,	"key_8e")
GUICtrlSetOnEvent($btn_9e,	"key_9e")
GUICtrlSetOnEvent($btn_0,	"key_0")
GUICtrlSetOnEvent($btn_0e,	"key_0e")
GUICtrlSetOnEvent($btn_chup,	"key_chup")
GUICtrlSetOnEvent($btn_chdn,	"key_chdn")
GUICtrlSetOnEvent($btn_volup,	"key_volup")
GUICtrlSetOnEvent($btn_voldn,	"key_voldn")
GUICtrlSetOnEvent($btn_favch,	"key_favch")
GUICtrlSetOnEvent($btn_prech,	"key_prech")
GUICtrlSetOnEvent($btn_mute,	"key_mute")
GUICtrlSetOnEvent($btn_source,	"key_source")
GUICtrlSetOnEvent($btn_info,	"key_info")
GUICtrlSetOnEvent($btn_menu,	"key_menu")
GUICtrlSetOnEvent($btn_guide,	"key_guide")
GUICtrlSetOnEvent($btn_tools,	"key_tools")
GUICtrlSetOnEvent($btn_return,	"key_return")
GUICtrlSetOnEvent($btn_enter,	"key_enter")
GUICtrlSetOnEvent($btn_up,		"key_up")
GUICtrlSetOnEvent($btn_left,	"key_left")
GUICtrlSetOnEvent($btn_right,	"key_right")
GUICtrlSetOnEvent($btn_down,	"key_down")
GUICtrlSetOnEvent($btn_intern,	"key_intern")
GUICtrlSetOnEvent($btn_exit,	"key_exit")
GUICtrlSetOnEvent($btn_red,		"key_red")
GUICtrlSetOnEvent($btn_green,	"key_green")
GUICtrlSetOnEvent($btn_yellow,	"key_yellow")
GUICtrlSetOnEvent($btn_blue,	"key_blue")
GUICtrlSetOnEvent($btn_ttx,		"key_ttx")
GUICtrlSetOnEvent($btn_media,	"key_media")
GUICtrlSetOnEvent($btn_conten,	"key_conten")
GUICtrlSetOnEvent($btn_chlist,	"key_chlist")
GUICtrlSetOnEvent($btn_ad,		"key_ad")
GUICtrlSetOnEvent($btn_subt,	"key_subt")
GUICtrlSetOnEvent($btn_fb,		"key_fb")
GUICtrlSetOnEvent($btn_pause,	"key_pause")
GUICtrlSetOnEvent($btn_ff,		"key_ff")
GUICtrlSetOnEvent($btn_rec,		"key_rec")
GUICtrlSetOnEvent($btn_play,	"key_play")
GUICtrlSetOnEvent($btn_stop,	"key_stop")
GUICtrlSetOnEvent($btn_srs,		"key_srs")
GUICtrlSetOnEvent($btn_sleep,	"key_sleep")
GUICtrlSetOnEvent($btn_pip,		"key_pip")
GUICtrlSetOnEvent($btn_pip1,	"key_pip1")
GUICtrlSetOnEvent($btn_pip2,	"key_pip2")
GUICtrlSetOnEvent($btn_pip_x,	"key_pip_x")
GUICtrlSetOnEvent($btn_energy,	"key_energy")
GUICtrlSetOnEvent($btn_smode,	"key_smode")
GUICtrlSetOnEvent($btn_pmode,	"key_pmode")
GUICtrlSetOnEvent($btn_dynamic,	"key_dynamic")
GUICtrlSetOnEvent($btn_standard,"key_standard")
GUICtrlSetOnEvent($btn_movie,	"key_movie")
GUICtrlSetOnEvent($btn_asp43,	"key_asp43")
GUICtrlSetOnEvent($btn_asp169,	"key_asp169")
GUICtrlSetOnEvent($btn_psize,	"key_psize")
GUICtrlSetOnEvent($btn_hdmi1,	"key_hdmi1")
GUICtrlSetOnEvent($btn_hdmi2,	"key_hdmi2")
GUICtrlSetOnEvent($btn_hdmi3,	"key_hdmi3")
GUICtrlSetOnEvent($btn_hdmi4,	"key_hdmi4")
GUICtrlSetOnEvent($btn_scart1,	"key_scart1")
GUICtrlSetOnEvent($btn_scart2,	"key_scart2")
GUICtrlSetOnEvent($btn_module,	"key_module")
GUICtrlSetOnEvent($btn_vga,		"key_vga")
GUICtrlSetOnEvent($btn_av,		"key_av")
GUICtrlSetOnEvent($btn_dvb,		"key_dvb")
GUICtrlSetOnEvent($btn_hnc,		"key_hnc")
GUICtrlSetOnEvent($btn_spk,		"key_spk")

GUICtrlSetOnEvent($cnt_config,	"cnt_config")
GUICtrlSetOnEvent($cnt_buttons,	"cnt_buttons")
GUICtrlSetOnEvent($cnt_tv_app,	"cnt_tv_app")
GUICtrlSetOnEvent($cnt_pc_app,	"cnt_pc_app")
GUICtrlSetOnEvent($cnt_www,		"cnt_www")
GUICtrlSetOnEvent($cnt_about,	"cnt_about")


While 1
	Sleep(250)
WEnd

Func cnt_config()
	$GUI_config = GUISetState()
EndFunc

Func cnt_buttons()
	If $extra_buttons = "1" Then
		$config_extra_buttons = IniWrite($config, "extra buttons", "visible", "0")
	ElseIf $extra_buttons = "0" Then
		$config_extra_buttons = IniWrite($config, "extra buttons", "visible", "1")
	EndIf
	restart()
EndFunc

Func cnt_tv_app()
	ShellExecute($tv_app)
EndFunc

Func cnt_pc_app()
	ShellExecute($pc_app)
EndFunc

Func cnt_www()
	ShellExecute("http://www.samygo.tv")
EndFunc

Func cnt_about()
	MsgBox(64, "About...", "   Created by: moras86" & @CRLF & @CRLF & "   Thanks to:" & @CRLF & "	- doodlecz" & @CRLF & "	- sbav1" & @CRLF & "	- juzis28" & @CRLF & @CRLF & "   SamyGO  2011")
EndFunc

Func key_tv()
	SendKeyCode(27)
EndFunc

Func key_1()
	SendKeyCode(4)
EndFunc

Func key_2()
	SendKeyCode(5)
EndFunc

Func key_3()
	SendKeyCode(6)
EndFunc

Func key_4()
	SendKeyCode(8)
EndFunc

Func key_5()
	SendKeyCode(9)
EndFunc

Func key_6()
	SendKeyCode(10)
EndFunc

Func key_7()
	SendKeyCode(12)
EndFunc

Func key_8()
	SendKeyCode(13)
EndFunc

Func key_9()
	SendKeyCode(14)
EndFunc

Func key_0()
	SendKeyCode(17)
EndFunc

Func key_1e()
	key_1()
	Sleep(100)
	key_enter()
EndFunc

Func key_2e()
	key_2()
	Sleep(100)
	key_enter()
EndFunc

Func key_3e()
	key_3()
	Sleep(100)
	key_enter()
EndFunc

Func key_4e()
	key_4()
	Sleep(100)
	key_enter()
EndFunc

Func key_5e()
	key_5()
	Sleep(100)
	key_enter()
EndFunc

Func key_6e()
	key_6()
	Sleep(100)
	key_enter()
EndFunc

Func key_7e()
	key_7()
	Sleep(100)
	key_enter()
EndFunc

Func key_8e()
	key_8()
	Sleep(100)
	key_enter()
EndFunc

Func key_9e()
	key_9()
	Sleep(100)
	key_enter()
EndFunc

Func key_0e()
	key_0()
	Sleep(100)
	key_enter()
EndFunc

Func key_favch()
	SendKeyCode(68)
EndFunc

Func key_prech()
	SendKeyCode(19)
EndFunc

Func key_volup()
	SendKeyCode(7)
EndFunc

Func key_voldn()
	SendKeyCode(11)
EndFunc

Func key_chup()
	SendKeyCode(18)
	If $info_ch=1 Then
		Sleep(250)
		key_info()
	EndIf
EndFunc

Func key_chdn()
	SendKeyCode(16)
	If $info_ch=1 Then
		Sleep(250)
		key_info()
	EndIf
EndFunc

Func key_mute()
	SendKeyCode(15)
EndFunc

Func key_source()
	SendKeyCode(1)
EndFunc

Func key_info()
	SendKeyCode(31)
EndFunc

Func key_tools()
	SendKeyCode(75)
EndFunc

Func key_guide()
	SendKeyCode(79)
EndFunc

Func key_return()
	SendKeyCode(88)
EndFunc

Func key_menu()
	SendKeyCode(26)
EndFunc

Func key_enter()
	SendKeyCode(104)
EndFunc

Func key_up()
	SendKeyCode(96)
EndFunc

Func key_down()
	SendKeyCode(97)
EndFunc

Func key_left()
	SendKeyCode(101)
EndFunc

Func key_right()
	SendKeyCode(98)
EndFunc

Func key_intern()
	SendKeyCode(147)
EndFunc

Func key_exit()
	SendKeyCode(45)
EndFunc

Func key_red()
	SendKeyCode(108)
EndFunc

Func key_green()
	SendKeyCode(20)
EndFunc

Func key_yellow()
	SendKeyCode(21)
EndFunc

Func key_blue()
	SendKeyCode(22)
EndFunc

Func key_ttx()
	SendKeyCode(44)
EndFunc

Func key_media()
	SendKeyCode(140)
EndFunc

Func key_conten()
	SendKeyCode(121)
EndFunc

Func key_chlist()
	SendKeyCode(107)
EndFunc

Func key_ad()
	SendKeyCode(39)
EndFunc

Func key_subt()
	SendKeyCode(37)
EndFunc

Func key_fb()
	SendKeyCode(69)
EndFunc

Func key_pause()
	SendKeyCode(74)
EndFunc

Func key_ff()
	SendKeyCode(72)
EndFunc

Func key_rec()
	SendKeyCode(73)
EndFunc

Func key_play()
	SendKeyCode(71)
EndFunc

Func key_stop()
	SendKeyCode(70)
EndFunc

Func key_sleep()
	SendKeyCode(3)
EndFunc

Func key_energy()
	SendKeyCode(119)
EndFunc

Func key_srs()
	SendKeyCode(110)
EndFunc

Func key_psize()
	SendKeyCode(62)
EndFunc

Func key_asp43()
	SendKeyCode(227)
EndFunc

Func key_asp169()
	SendKeyCode(228)
EndFunc

Func key_smode()
	SendKeyCode(43)
EndFunc

Func key_pmode()
	SendKeyCode(40)
EndFunc

Func key_dynamic()
	SendKeyCode(189)
EndFunc

Func key_standard()
	SendKeyCode(223)
EndFunc

Func key_movie()
	SendKeyCode(222)
EndFunc

Func key_scart1()
	SendKeyCode(132)
EndFunc

Func key_scart2()
	SendKeyCode(235)
EndFunc

Func key_module()
	SendKeyCode(134)
EndFunc

Func key_av()
	SendKeyCode(236)
EndFunc

Func key_vga()
	SendKeyCode(105)
EndFunc

Func key_hdmi1()
	SendKeyCode(233)
EndFunc

Func key_hdmi2()
	SendKeyCode(190)
EndFunc

Func key_hdmi3()
	SendKeyCode(194)
EndFunc

Func key_hdmi4()
	SendKeyCode(197)
EndFunc

Func key_pip()
	SendKeyCode(32)
EndFunc

Func key_pip1()
	SendKeyCode(520)
	GUICtrlSetState($btn_pip_x, $GUI_ENABLE)
EndFunc

Func key_pip2()
	SendKeyCode(523)
	GUICtrlSetState($btn_pip_x, $GUI_ENABLE)
EndFunc

Func key_dual()
	SendKeyCode(0)
EndFunc

Func key_power()
	If MsgBox(33, "Power OFF TV", "   Are you sure you want to shutdown TV and close app?") = 1 Then
		SendKeyCode(2)
		end()
	EndIf
EndFunc

Func key_pip_x()
	key_guide()
	Sleep(2000)
	key_return()
	GUICtrlSetState($btn_pip_x, $GUI_DISABLE)
EndFunc

Func key_dvb()
	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_dvb, $GUI_DISABLE)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GuiCtrlSetData($progress, 5)
	Sleep(1000)
	key_tv()
	GUICtrlSetState($btn_tv, $GUI_FOCUS)
	GuiCtrlSetData($progress, 10)
	Sleep(2000)
	key_menu()
	GUICtrlSetState($btn_menu, $GUI_FOCUS)
	GuiCtrlSetData($progress, 23)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 36)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 49)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GuiCtrlSetData($progress, 62)
	Sleep(1000)
	If $alt_dvb = "1" Then
		key_down()
		GUICtrlSetState($btn_down, $GUI_FOCUS)
		GuiCtrlSetData($progress, 68)
		Sleep(1000)
	EndIf
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 75)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 88)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_dvb, $GUI_ENABLE)
	GUICtrlSetState($btn_dvb, $GUI_FOCUS)
	GUICtrlSetState($btn_dvb, $GUI_HIDE)
	GUICtrlSetState($btn_dvb, $GUI_SHOW)
	GUICtrlSetState($progress, $GUI_HIDE)
	GuiCtrlSetData($progress, 0)
EndFunc

Func key_hnc()
	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_hnc, $GUI_DISABLE)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GuiCtrlSetData($progress, 5)
	Sleep(1000)
	key_tv()
	GUICtrlSetState($btn_tv, $GUI_FOCUS)
	GuiCtrlSetData($progress, 10)
	Sleep(2000)
	key_menu()
	GUICtrlSetState($btn_menu, $GUI_FOCUS)
	GuiCtrlSetData($progress, 18)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 26)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 34)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 42)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 50)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 58)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 66)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 74)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 82)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GuiCtrlSetData($progress, 90)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_hnc, $GUI_ENABLE)
	GUICtrlSetState($btn_hnc, $GUI_FOCUS)
	GUICtrlSetState($btn_hnc, $GUI_HIDE)
	GUICtrlSetState($btn_hnc, $GUI_SHOW)
	GUICtrlSetState($progress, $GUI_HIDE)
	GuiCtrlSetData($progress, 0)
EndFunc

Func key_spk()
	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_spk, $GUI_DISABLE)
	key_menu()
	GUICtrlSetState($btn_menu, $GUI_FOCUS)
	GuiCtrlSetData($progress, 11)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GuiCtrlSetData($progress, 22)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 33)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 44)
	Sleep(1000)
	key_up()
	GUICtrlSetState($btn_up, $GUI_FOCUS)
	GuiCtrlSetData($progress, 55)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 66)
	Sleep(1000)
	key_down()
	GUICtrlSetState($btn_down, $GUI_FOCUS)
	GuiCtrlSetData($progress, 77)
	Sleep(1000)
	key_enter()
	GUICtrlSetState($btn_enter, $GUI_FOCUS)
	GuiCtrlSetData($progress, 88)
	Sleep(1000)
	key_exit()
	GUICtrlSetState($btn_exit, $GUI_FOCUS)
	GuiCtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_spk, $GUI_ENABLE)
	GUICtrlSetState($btn_spk, $GUI_FOCUS)
	GUICtrlSetState($btn_spk, $GUI_HIDE)
	GUICtrlSetState($btn_spk, $GUI_SHOW)
	GUICtrlSetState($progress, $GUI_HIDE)
	GuiCtrlSetData($progress, 0)
EndFunc

Func key_user1()
	SendKeyCode($user_btn_keycode1)
EndFunc

Func key_user2()
	SendKeyCode($user_btn_keycode2)
EndFunc

Func key_user_seq()
	$user_btn_key1_get = GUICtrlRead($user_btn_key1_input)
	$user_btn_key2_get = GUICtrlRead($user_btn_key2_input)
	$user_btn_key3_get = GUICtrlRead($user_btn_key3_input)
	$user_btn_key4_get = GUICtrlRead($user_btn_key4_input)
	$user_btn_key5_get = GUICtrlRead($user_btn_key5_input)
	$user_btn_key6_get = GUICtrlRead($user_btn_key6_input)
	$user_btn_key7_get = GUICtrlRead($user_btn_key7_input)
	$user_btn_key8_get = GUICtrlRead($user_btn_key8_input)
	$user_btn_key9_get = GUICtrlRead($user_btn_key9_input)
	$user_btn_key0_get = GUICtrlRead($user_btn_key0_input)

	GUICtrlSetState($progress, $GUI_SHOW)
	GUICtrlSetState($btn_user_seq, $GUI_DISABLE)
	if $user_btn_key1_get <> "" Then
		GuiCtrlSetData($progress, 5)
		If $user_btn_key1_get <> "-" Then
			SendKeyCode($user_btn_key1_get)
			Sleep(1000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 10)
	if $user_btn_key2_get <> "" Then
		GuiCtrlSetData($progress, 15)
		If $user_btn_key2_get <> "-" Then
			SendKeyCode($user_btn_key2_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 20)
	if $user_btn_key3_get <> "" Then
		GuiCtrlSetData($progress, 25)
		If $user_btn_key3_get <> "-" Then
			SendKeyCode($user_btn_key3_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 30)
	if $user_btn_key4_get <> "" Then
		GuiCtrlSetData($progress, 35)
		If $user_btn_key4_get <> "-" Then
			SendKeyCode($user_btn_key4_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 40)
	if $user_btn_key5_get <> "" Then
		GuiCtrlSetData($progress, 45)
		If $user_btn_key5_get <> "-" Then
			SendKeyCode($user_btn_key5_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 50)
	if $user_btn_key6_get <> "" Then
		GuiCtrlSetData($progress, 55)
		If $user_btn_key6_get <> "-" Then
			SendKeyCode($user_btn_key6_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 60)
	if $user_btn_key7_get <> "" Then
		GuiCtrlSetData($progress, 65)
		If $user_btn_key7_get <> "-" Then
			SendKeyCode($user_btn_key7_get)
			Sleep(1000)
		Else

			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 70)
	if $user_btn_key8_get <> "" Then
		GuiCtrlSetData($progress, 75)
		If $user_btn_key8_get <> "-" Then
			SendKeyCode($user_btn_key8_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 80)
	if $user_btn_key9_get <> "" Then
		GuiCtrlSetData($progress, 85)
		If $user_btn_key9_get <> "-" Then
			SendKeyCode($user_btn_key9_get)
			Sleep(1000)
		Else
			Sleep(2000)
		EndIf
	EndIf
	GuiCtrlSetData($progress, 90)
	if $user_btn_key0_get <> "" Then
		GuiCtrlSetData($progress, 95)
		SendKeyCode($user_btn_key0_get)
	EndIf
	GuiCtrlSetData($progress, 100)
	Sleep(2000)
	GUICtrlSetState($btn_user_seq, $GUI_ENABLE)
	GUICtrlSetState($progress, $GUI_HIDE)
	GuiCtrlSetData($progress, 0)
EndFunc

Func SendKeycode($keycode)
	Local $sc
	TCPStartup()
	While 1
		$sc = TCPConnect($tv_ip, 2345)
		If @error Then
			If MsgBox(17, "Error - " & @error, "   TCPConnect failed with WSA error: " & @error & @CRLF & @CRLF & "   Click 'Cancel' button to exit application.") = 2 Then end()
			ExitLoop
		Endif
		TCPSend($sc, $keycode & @LF)
		TCPCloseSocket($sc)
		ExitLoop
	WEnd
	TCPShutdown()
EndFunc

Func save_config()
		$tv_ip_get = _GUICtrlIpAddress_Get($tv_ip_input)
	$config_tv_ip				= IniWrite($config, "connect", "ip", $tv_ip_get)
		If GUICtrlRead($tv_model_b650) = $GUI_CHECKED Then
			$tv_model_get = "B650"
		ElseIf GUICtrlRead($tv_model_b6000) = $GUI_CHECKED Then
			$tv_model_get = "B6000"
		EndIf
	$config_tv_model			= IniWrite($config, "model", "tv", $tv_model_get)
		If GUICtrlRead($tv_remote_list) = "BN59-00938A" Then
			$tv_remote_get = "938"
		ElseIf GUICtrlRead($tv_remote_list) = "BN59-00861A" Then
			$tv_remote_get = "861"
		EndIf
	$config_tv_remote			= IniWrite($config, "model", "rc", $tv_remote_get)
		$user_button_get = "0"
		If GUICtrlRead($user_button_active1) = $GUI_CHECKED Then
			$user_button_get = "1"
		EndIf
		If (GUICtrlRead($user_button_active1) = $GUI_CHECKED) and (GUICtrlRead($user_button_active2) = $GUI_CHECKED) Then
			$user_button_get = "2"
		EndIf
	$config_user_btn			= IniWrite($config, "user button", "active", $user_button_get)
		$user_box_name_get = GUICtrlRead($user_box_name_input)
	$config_user_box_name		= IniWrite($config, "user button", "box name", $user_box_name_get)
		$user_btn_name1_get = GUICtrlRead($user_btn_name1_input)
	$config_user_btn_name1		= IniWrite($config, "user button", "name1", $user_btn_name1_get)
		$user_btn_keycode1_get = GUICtrlRead($user_btn_keycode1_input)
	$config_user_btn_keycode1	= IniWrite($config, "user button", "keycode1", $user_btn_keycode1_get)
		$user_btn_name2_get = GUICtrlRead($user_btn_name2_input)
	$config_user_btn_name2		= IniWrite($config, "user button", "name2", $user_btn_name2_get)
		$user_btn_keycode2_get = GUICtrlRead($user_btn_keycode2_input)
	$config_user_btn_keycode2	= IniWrite($config, "user button", "keycode2", $user_btn_keycode2_get)
		If GUICtrlRead($user_btn_seq_active) = $GUI_CHECKED Then
			$user_btn_seq_get = "1"
		Else
			$user_btn_seq_get = "0"
		EndIf
	$config_user_btn_seq		= IniWrite($config, "user button", "seq", $user_btn_seq_get)
		$user_btn_name_get = GUICtrlRead($user_btn_name_input)
	$config_user_btn_name		= IniWrite($config, "user button", "name", $user_btn_name_get)
		$user_btn_key1_get = GUICtrlRead($user_btn_key1_input)
	$config_user_btn_key1		= IniWrite($config, "user button", "key1", $user_btn_key1_get)
		$user_btn_key2_get = GUICtrlRead($user_btn_key2_input)
	$config_user_btn_key2		= IniWrite($config, "user button", "key2", $user_btn_key2_get)
		$user_btn_key3_get = GUICtrlRead($user_btn_key3_input)
	$config_user_btn_key3		= IniWrite($config, "user button", "key3", $user_btn_key3_get)
		$user_btn_key4_get = GUICtrlRead($user_btn_key4_input)
	$config_user_btn_key4		= IniWrite($config, "user button", "key4", $user_btn_key4_get)
		$user_btn_key5_get = GUICtrlRead($user_btn_key5_input)
	$config_user_btn_key5		= IniWrite($config, "user button", "key5", $user_btn_key5_get)
		$user_btn_key6_get = GUICtrlRead($user_btn_key6_input)
	$config_user_btn_key6		= IniWrite($config, "user button", "key6", $user_btn_key6_get)
		$user_btn_key7_get = GUICtrlRead($user_btn_key7_input)
	$config_user_btn_key7		= IniWrite($config, "user button", "key7", $user_btn_key7_get)
		$user_btn_key8_get = GUICtrlRead($user_btn_key8_input)
	$config_user_btn_key8		= IniWrite($config, "user button", "key8", $user_btn_key8_get)
		$user_btn_key9_get = GUICtrlRead($user_btn_key9_input)
	$config_user_btn_key9		= IniWrite($config, "user button", "key9", $user_btn_key9_get)
		$user_btn_key0_get = GUICtrlRead($user_btn_key0_input)
	$config_user_btn_key0		= IniWrite($config, "user button", "key0", $user_btn_key0_get)
		If GUICtrlRead($hotkeys_numeric_active) = $GUI_CHECKED Then
			$hotkeys_numeric_get = "1"
		Else
			$hotkeys_numeric_get = "0"
		EndIf
	$config_hotkeys_numeric		= IniWrite($config, "hotkeys", "numeric", $hotkeys_numeric_get)
		If GUICtrlRead($hotkeys_arrows_active) = $GUI_CHECKED Then
			$hotkeys_arrows_get = "1"
		Else
			$hotkeys_arrows_get = "0"
		EndIf
	$config_hotkeys_arrows		= IniWrite($config, "hotkeys", "arrows", $hotkeys_arrows_get)
		If GUICtrlRead($hotkeys_media_active) = $GUI_CHECKED Then
			$hotkeys_media_get = "1"
		Else
			$hotkeys_media_get = "0"
		EndIf
	$config_hotkeys_media		= IniWrite($config, "hotkeys", "media", $hotkeys_media_get)
		If GUICtrlRead($extra_buttons_active) = $GUI_CHECKED Then
			$extra_buttons_get = "1"
		Else
			$extra_buttons_get = "0"
		EndIf
	$config_extra_buttons		= IniWrite($config, "extra buttons", "visible", $extra_buttons_get)
	If GUICtrlRead($fast_btn_active) = $GUI_CHECKED Then
			$fast_btn_get = "1"
		Else
			$fast_btn_get = "0"
		EndIf
	$config_fast_btn			= IniWrite($config, "other", "fast_btn", $fast_btn_get)
		If GUICtrlRead($info_ch_active) = $GUI_CHECKED Then
			$info_ch_get = "1"
		Else
			$info_ch_get = "0"
		EndIf
	$config_info_ch				= IniWrite($config, "other", "info_ch", $info_ch_get)
		If GUICtrlRead($alt_dvb_active) = $GUI_CHECKED Then
			$alt_dvb_get = "1"
		Else
			$alt_dvb_get = "0"
		EndIf
	$config_alt_dvb				= IniWrite($config, "other", "alt_dvb", $alt_dvb_get)
	GUICtrlSetState($btn_restart_config, $GUI_ENABLE)
	GUICtrlSetState($btn_restart_config, $GUI_FOCUS)
	GUICtrlCreateLabel("App need to be restart after changes.", 130, 201)
	GUICtrlSetBkColor(-1, 0xFFFFFF)
	GuiCtrlSetColor(-1, 0xFF0000)
EndFunc

Func _Tab_Switch()
	Local $iCurrTab = GUICtrlRead($Tab)
	If $iCurrTab <> $iLastTab Then
		Switch $iCurrTab
			Case 0
				WinSetState($tv_ip_input, "", @SW_SHOW)
			Case 1
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 2
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 3
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 4
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 5
				WinSetState($tv_ip_input, "", @SW_HIDE)
			Case 6
				WinSetState($tv_ip_input, "", @SW_HIDE)
		EndSwitch
		$iLastTab = $iCurrTab
	EndIf
EndFunc

Func config_box()
   $GUI_config = GUISetState(@SW_HIDE)
EndFunc

Func restart()
	_ScriptRestart(1)
EndFunc

Func end()
	Exit
EndFunc